open Base

type t = (string * string) list [@@deriving show]

let empty = []

let find t ~key =
  List.Assoc.find t ~equal:String.Caseless.equal key

let set t ~key ~value =
  List.Assoc.add t ~equal:String.Caseless.equal key value

let remove t ~key =
  List.Assoc.remove t ~equal:String.Caseless.equal key

let of_list lst =
  List.fold lst ~init:[] ~f:begin fun acc el ->
    set acc ~key:(fst el) ~value:(snd el)
  end

let to_list t =
  t
