open Alcotest
open Base
open Okweb

let test_read_up_to_respects_the_limit =
  test_case "read_up_to respects the limit" `Quick begin fun () ->
    let body = Lwt_stream.of_list ["one"; "two"; "three"] |> Body.of_stream in
    check string
      "invalid body"
      "onetwo"
      (Body.read_up_to ~max_bytes:8 body |> Lwt_main.run)
  end

let test_read_up_to_always_returns_full_string =
  let body = Body.of_string "test" in
  QCheck.Test.make QCheck.pos_int
    ~name:"read_up_to always returns full string"
    begin fun max_bytes ->
      String.equal "test" (Body.read_up_to ~max_bytes body |> Lwt_main.run)
    end

let cases = List.concat [[
    test_read_up_to_respects_the_limit;
  ]; List.map ~f:QCheck_alcotest.to_alcotest [
    test_read_up_to_always_returns_full_string;
  ]]
